/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 12, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.corefoundation.CFCharacterSet;

import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFData;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

struct __CFCharacterSet;
alias __CFCharacterSet* CFCharacterSetRef;
alias __CFCharacterSet* CFMutableCharacterSetRef;
alias int CFCharacterSetPredefinedSet;

enum
{
	kCFCharacterSetControl = 1,
	kCFCharacterSetWhitespace,
	kCFCharacterSetWhitespaceAndNewline,
	kCFCharacterSetDecimalDigit,
	kCFCharacterSetLetter,
	kCFCharacterSetLowercaseLetter,
	kCFCharacterSetUppercaseLetter,
	kCFCharacterSetNonBase,
	kCFCharacterSetDecomposable,
	kCFCharacterSetAlphaNumeric,
	kCFCharacterSetPunctuation,
	kCFCharacterSetCapitalizedLetter = 13,
	kCFCharacterSetSymbol = 14,
	kCFCharacterSetNewline = 15,
	kCFCharacterSetIllegal = 12
}

extern (C)
{
	uint CFCharacterSetGetTypeID ();
	CFCharacterSetRef CFCharacterSetGetPredefined (int theSetIdentifier);
	CFCharacterSetRef CFCharacterSetCreateWithCharactersInRange (CFAllocatorRef alloc, CFRange theRange);
	CFCharacterSetRef CFCharacterSetCreateWithCharactersInString (CFAllocatorRef alloc, CFStringRef theString);
	CFCharacterSetRef CFCharacterSetCreateWithBitmapRepresentation (CFAllocatorRef alloc, CFDataRef theData);
	CFCharacterSetRef CFCharacterSetCreateInvertedSet (CFAllocatorRef alloc, CFCharacterSetRef theSet);
	ubyte CFCharacterSetIsSupersetOfSet (CFCharacterSetRef theSet, CFCharacterSetRef theOtherset);
	ubyte CFCharacterSetHasMemberInPlane (CFCharacterSetRef theSet, int thePlane);
	CFMutableCharacterSetRef CFCharacterSetCreateMutable (CFAllocatorRef alloc);
	CFCharacterSetRef CFCharacterSetCreateCopy (CFAllocatorRef alloc, CFCharacterSetRef theSet);
	CFMutableCharacterSetRef CFCharacterSetCreateMutableCopy (CFAllocatorRef alloc, CFCharacterSetRef theSet);
	ubyte CFCharacterSetIsCharacterMember (CFCharacterSetRef theSet, wchar theChar);
	ubyte CFCharacterSetIsLongCharacterMember (CFCharacterSetRef theSet, uint theChar);
	CFDataRef CFCharacterSetCreateBitmapRepresentation (CFAllocatorRef alloc, CFCharacterSetRef theSet);
	void CFCharacterSetAddCharactersInRange (CFMutableCharacterSetRef theSet, CFRange theRange);
	void CFCharacterSetRemoveCharactersInRange (CFMutableCharacterSetRef theSet, CFRange theRange);
	void CFCharacterSetAddCharactersInString (CFMutableCharacterSetRef theSet, CFStringRef theString);
	void CFCharacterSetRemoveCharactersInString (CFMutableCharacterSetRef theSet, CFStringRef theString);
	void CFCharacterSetUnion (CFMutableCharacterSetRef theSet, CFCharacterSetRef theOtherSet);
	void CFCharacterSetIntersect (CFMutableCharacterSetRef theSet, CFCharacterSetRef theOtherSet);
	void CFCharacterSetInvert (CFMutableCharacterSetRef theSet);
}