/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 21, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coreservices.carboncore.StringCompare;

//import dstep.AvailabilityMacros;
import dstep.coreservices.carboncore.MacTypes;
import dstep.coreservices.carboncore.MixedMode;
import dstep.coreservices.carboncore.Script;
import dstep.coreservices.carboncore.TextCommon;
import dstep.internal.Version;

enum
{
	systemCurLang = -2,
	systemDefLang = -3,
	currentCurLang = -4,
	currentDefLang = -5,
	scriptCurLang = -6,
	scriptDefLang = -7
}

enum
{
	iuSystemCurLang = systemCurLang,
	iuSystemDefLang = systemDefLang,
	iuCurrentCurLang = currentCurLang,
	iuCurrentDefLang = currentDefLang,
	iuScriptCurLang = scriptCurLang,
	iuScriptDefLang = scriptDefLang
}

static if (!D_LP64):
extern (C):
	
short MacReplaceText (Handle baseText, Handle substitutionText, Str15 key);
short ScriptOrder (ScriptCode script1, ScriptCode script2);
short MacCompareString (ConstStr255Param aStr, ConstStr255Param bStr, Handle itl2Handle);
short IdenticalString (ConstStr255Param aStr, ConstStr255Param bStr, Handle itl2Handle);
short StringOrder (ConstStr255Param aStr, ConstStr255Param bStr, ScriptCode aScript, ScriptCode bScript, LangCode aLang, LangCode bLang);
short CompareText (/*const*/ void* aPtr, /*const*/ void* bPtr, short aLen, short bLen, Handle itl2Handle);
short IdenticalText (/*const*/ void* aPtr, /*const*/ void* bPtr, short aLen, short bLen, Handle itl2Handle);
short TextOrder (/*const*/ void* aPtr, /*const*/ void* bPtr, short aLen, short bLen, ScriptCode aScript, ScriptCode bScript, LangCode aLang, LangCode bLang);
short LanguageOrder (LangCode language1, LangCode language2);
short RelString (ConstStr255Param str1, ConstStr255Param str2, bool caseSensitive, bool diacSensitive);
bool EqualString (ConstStr255Param str1, ConstStr255Param str2, bool caseSensitive, bool diacSensitive);
short relstring (/*const*/ char* str1, /*const*/ char* str2, bool caseSensitive, bool diacSensitive);