/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 22, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coreservices.cfnetwork.CFProxySupport;

//import dstep.Availability;
import dstep.coreservices.cfnetwork.CFNetworkDefs;
import dstep.corefoundation.CFArray;
import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFDictionary;
import dstep.corefoundation.CFError;
import dstep.corefoundation.CFRunLoop;
import dstep.corefoundation.CFStream;
import dstep.corefoundation.CFString;
import dstep.corefoundation.CFURL;

extern (C)
{
	alias void function (void*, CFArrayRef, CFErrorRef) CFProxyAutoConfigurationResultCallback;
}

extern (C)
{
	extern
	{
		const CFStringRef kCFProxyTypeKey;
		const CFStringRef kCFProxyHostNameKey;
		const CFStringRef kCFProxyPortNumberKey;
		const CFStringRef kCFProxyAutoConfigurationURLKey;
		const CFStringRef kCFProxyUsernameKey;
		const CFStringRef kCFProxyPasswordKey;
		const CFStringRef kCFProxyTypeNone;
		const CFStringRef kCFProxyTypeHTTP;
		const CFStringRef kCFProxyTypeHTTPS;
		const CFStringRef kCFProxyTypeSOCKS;
		const CFStringRef kCFProxyTypeFTP;
		const CFStringRef kCFProxyTypeAutoConfigurationURL;
	}
}

extern (C)
{
	CFArrayRef CFNetworkCopyProxiesForURL (CFURLRef url, CFDictionaryRef proxySettings);
	CFArrayRef CFNetworkCopyProxiesForAutoConfigurationScript (CFStringRef proxyAutoConfigurationScript, CFURLRef targetURL, CFErrorRef* error);
	CFRunLoopSourceRef CFNetworkExecuteProxyAutoConfigurationScript (CFStringRef proxyAutoConfigurationScript, CFURLRef targetURL, CFProxyAutoConfigurationResultCallback cb, CFStreamClientContext* clientContext);
	CFRunLoopSourceRef CFNetworkExecuteProxyAutoConfigurationURL (CFURLRef proxyAutoConfigURL, CFURLRef targetURL, CFProxyAutoConfigurationResultCallback cb, CFStreamClientContext* clientContext);
	CFDictionaryRef CFNetworkCopySystemProxySettings ();
}